/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.7 beta 5 Professional
Automatic Program Generator
 Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 02.03.2008
Author  : Spiritus Sancti                            
Company : licrym.org                            
Comments: 


Chip type           : ATmega8
Program type        : Application
Clock frequency     : 16,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>
#include <stdlib.h>
#include <delay.h> 

#define ADC_VREF_TYPE 0x40   

#define gTimeOfMove 976  
//     (1 )  



unsigned int gtime; 
bit ADC_complete, env_free=1 ;
unsigned char sensor_state, sensor_state_last;     //  ,      
unsigned int gADC_result;
unsigned char now, h, step;
// 
//
//      1   0   2
//        \ | /
//         [ ]
//        / | \
//       3  4  5

unsigned char gporog[6]={100, 150, 150, 200, 125, 200};       //    
                                                              //    30 
unsigned char d[7][7]={  //  ,  -  ,  - .
//          STO    F   FR    FL    B   BR   BL
/*STO*/     {10,  15,  15,   15,  15,  15,  15},
/*F  */     {17,  23,  25,   25,   0,   0,   0},
/*FR */     {17,  23,  25,   25,   0,   0,   0},
/*FL */     {17,  33,  25,   25,   0,   0,   0},
/*B  */     {25,   0,   0,    0,  25,  25,  25},
/*BR */     {25,   0,   0,    0,  25,  25,  25},
/*BL */     {25,   0,   0,    0,  25,  25,  25}
};   

unsigned char etalon[7][7]={  //  ,     
//          STO    F   FR    FL    B   BR   BL
/*STO*/     {10,  15,  15,   15,  15,  15,  15},
/*F  */     {17,  23,  25,   25,   0,   0,   0},
/*FR */     {17,  23,  25,   25,   0,   0,   0},
/*FL */     {17,  33,  25,   25,   0,   0,   0},
/*B  */     {25,   0,   0,    0,  25,  25,  25},
/*BR */     {25,   0,   0,    0,  25,  25,  25},
/*BL */     {25,   0,   0,    0,  25,  25,  25}
};   

//  ,   6  disable

void disable_FR(void)            //      
{
   unsigned char i;              //             
   for (i=0;i<7;i++){            //      
     d[i][0] += d[i][1];         //S<-F
     d[i][1] = 0;
     d[i][3] += d[i][2];         //FL<-FR
     d[i][2] = 0; 
     d[i][0] += d[i][5];         //S<-BR
     d[i][5] = 0; 
   }
}

void disable_FL(void)            //      
{
   unsigned char i;     
   for (i=0;i<7;i++){   
     d[i][0] += d[i][1];         //S<-F
     d[i][1] = 0;
     d[i][2] += d[i][3];         //FR<-FL
     d[i][3] = 0; 
     d[i][0] += d[i][6];         //S<-BL
     d[i][6] = 0; 
   }
}
 
void disable_BR(void)            //      
{
   unsigned char i;     
   for (i=0;i<7;i++){   
     d[i][0] += d[i][4];         //S<-B
     d[i][4] = 0;
     d[i][6] += d[i][5];         //BL<-BR
     d[i][5] = 0; 
     d[i][0] += d[i][2];         //S<-FR
     d[i][2] = 0; 
   }
}

void disable_BL(void)            //      
{
   unsigned char i;     
   for (i=0;i<7;i++){   
     d[i][0] += d[i][4];         //S<-B
     d[i][4] = 0;
     d[i][5] += d[i][6];         //BR<-BL
     d[i][6] = 0; 
     d[i][0] += d[i][3];         //S<-FL
     d[i][3] = 0; 
   }
}

void disable_allF(void)          //    
{
   unsigned char i;     
   if (d[0][4]!=0)  //        
   {
    for (i=0;i<7;i++){   
         d[i][4] += d[i][1];
         d[i][1] = 0;
         d[i][5] += d[i][2];
         d[i][2] = 0;
         d[i][6] += d[i][3];
         d[i][3] = 0;
    } 
   }else
     {
      for (i=0;i<7;i++){   
         d[i][0] += d[i][1];
         d[i][1] = 0;
         d[i][0] += d[i][2];
         d[i][2] = 0;
         d[i][0] += d[i][3];
         d[i][3] = 0;
      }
     }
     
}

void disable_allB(void)          //    
{
   unsigned char i;     
   if (d[0][1]!=0)  //        
   {
    for (i=0;i<7;i++){   
         d[i][1] += d[i][4];
         d[i][4] = 0;
         d[i][2] += d[i][5];
         d[i][5] = 0;
         d[i][3] += d[i][6];
         d[i][6] = 0;
    } 
   }else
     {
      for (i=0;i<7;i++){   
         d[i][0] += d[i][4];
         d[i][4] = 0;
         d[i][0] += d[i][5];
         d[i][5] = 0;
         d[i][0] += d[i][6];
         d[i][6] = 0;
      }
     }
     
}
 
void enable_all(void)            //  -     
{
  unsigned char a, b;
  for(a=0;a<7;a++)
  {
    for(b=0;b<7;b++)
    {
        d[a][b]=etalon[a][b];
    }
  }
  env_free=1;
}

void restore(void)
{   
  unsigned char a, b;
  if (step==3) enable_all();    //  
  if (step<3)
  {
    for(a=0;a<7;a++)
    {
      for(b=0;b<7;b++)
      {
        if (d[a][b]<etalon[a][b])
        d[a][b]+=(etalon[a][b] / 4);
         else
            d[a][b]-=(etalon[a][b] / 4);
      };
      step+=1;
   };
  };
}

interrupt [TIM1_COMPA] void timer1_compa_isr(void)//     1/976 
{
  if (gtime!=0) --gtime;   
}  
     
void delay (unsigned int time)                  //   ,  65535
{   
  gtime=time;
  while(gtime!=0){};
}     



// ADC interrupt service routine
interrupt [ADC_INT] void adc_isr(void)          //   
{ 
  unsigned int adc_data;
  // Read the AD conversion result
  adc_data=ADCW;
  gADC_result=adc_data;
  ADC_complete=1;
}
                                           
int poll_sensor(unsigned char SensorNumber)     //  
{  
  int delta; 
  ADMUX&=0b11110000;                             //     
  switch(SensorNumber)                    //  
  { 
     case 0:
        ADMUX|=0b00000000;
        break;
     case 1:
        ADMUX|=0b00000001;
        break;
     case 2:
        ADMUX|=0b00000010;
        break;
     case 3:
        ADMUX|=0b00000011;
        break;
     case 4:
        ADMUX|=0b00000100;
        break;            
     case 5:
        ADMUX|=0b00000101;
        break;
     default:
        ADMUX|=0b00000000;
        break;
  };
  PORTD.5=1;
  delay_us(50);           //   
  ADCSRA|=0x40;           //    
  while(ADC_complete!=1); //    
  delta=gADC_result;
  ADC_complete=0;         // 
 
  PORTD.5=0;              //    
  delay_us(10);
  ADCSRA|=0x40;
  while(ADC_complete!=1);
  delta=gADC_result-delta;
  ADC_complete=0;
  return delta;           //   
} 

void check_env(void)     //    
{   
  unsigned char i, a, b, c;

  for(i=0; i<6; i++)         //    
  {      
    a=poll_sensor(i);        //  3    
    b=poll_sensor(i);        //        
    c=poll_sensor(i);
    if(c>=gporog[i]) c=1; else c=0;
    if(b>=gporog[i]) b=1; else b=0;
    if(a>=gporog[i]) a=1; else a=0;
    c=c+b+a;
    if(c>=2)sensor_state|=1<<i; 
     else sensor_state&=~(1<<i);     //    1     ,   -    
  }; 
  if(sensor_state!=0)
  {
    env_free=0;     //  
    step=0;         //  ,   
  };
}
  
void delay_walk (unsigned int time)     //   ,  65535, 
{   // ,     
  gtime=time;
  while(gtime!=0)
  {
      check_env();
      if (sensor_state != sensor_state_last) //       
      {
        //delay_ms(200);                 //       0,2       
        break;
      };                               //        
  };                                   //   20  (0,2)
} 

//   
void f(int t)            // 
{   
 PORTD.1=0;
 PORTD.2=1;
 PORTD.3=0;
 PORTD.4=0;
 if(t!=0) delay_walk(t);
}

void b(int t)            // 
{  
 PORTD.1=1;
 PORTD.2=0;
 PORTD.3=0;
 PORTD.4=0;
 if(t!=0) delay_walk(t);
}

void fl(int t)          //  
{   
 PORTD.1=0;
 PORTD.2=1;
 PORTD.3=0;
 PORTD.4=1;
 if(t!=0) delay_walk(t);
} 

void fr(int t)          //  
{  
 PORTD.1=0;
 PORTD.2=1;
 PORTD.3=1;
 PORTD.4=0;
 if(t!=0) delay_walk(t);
}  

void bl(int t)          //  
{ 
 PORTD.1=1;
 PORTD.2=0;
 PORTD.3=0;
 PORTD.4=1;
 if(t!=0) delay_walk(t);
} 

void br(int t)          //  
{ 
 PORTD.1=1;
 PORTD.2=0;
 PORTD.3=1;
 PORTD.4=0;
 if(t!=0) delay_walk(t);
}
 
void stop(int t)        //
{ 
 PORTD.1=0;
 PORTD.2=0;
 PORTD.3=0;
 PORTD.4=0;
 if(t!=0) delay_walk(t);
} 

void led_on(void)       // 
{ 
 PORTD.0=1;
} 

void led_off(void)      // 
{ 
PORTD.0=0;
}    

void go(unsigned char napr)    //       
{     
  switch(napr)
  {
     case 0:
        stop(gTimeOfMove);
        break; 
     case 1:
        f(gTimeOfMove);
        break;
     case 2:
        fr(gTimeOfMove);
        break;
     case 3:
        fl(gTimeOfMove);
        break;
     case 4:
        b(gTimeOfMove);
        break;
     case 5:
        br(gTimeOfMove);
        break;
     case 6:
        bl(gTimeOfMove);
        break;
  };
}

unsigned char next_move(void)    //       
{   
  int a, b, c;
  a = rand()/327; 		         //0..99  
  c=0;
  for (b=0; b<=6; b++)           //  
  {      	  
      if(a > c && a < (d[now][b]+c) ) break;
      c=c+d[now][b];
  }; 
  if (b==7)b=0;                  // b  7   ,     ,               
  now = b;
  return b;
};    

 
void decision(void)                 //,        
{ bit sensor_des=0;                   //    
   if (sensor_state==0b00000010)    //           
   {
        disable_FL();
        sensor_des=1;
   };
   if (sensor_state==0b00000100)
   {
        disable_FR();
        sensor_des=1;
   };
   if (sensor_state==0b00001000)
   {    disable_BL();
        sensor_des=1;
   };
   if (sensor_state==0b00100000)
   {    disable_BR();                
        sensor_des=1;
   };
                                    //   2   
   if (sensor_state==0x03 || sensor_state==0x07 || sensor_state==0x05 || sensor_state==0x01)
   {    disable_allF();
        sensor_des=1;
   };
   
   if (sensor_state==0x18 || sensor_state==0x10 || sensor_state==0x30 || sensor_state==0x38)
   {    disable_allB();
        sensor_des=1;
   };
   //env_free     0   
 /*  if (sensor_state==0 && env_free==0)       //         
   {
       restore();
       sensor_des=1;
   };*/
   if (sensor_state!=0)                      //        
   {
       now=0;
       stop(0);
   };
   sensor_state_last=sensor_state;  
   if (sensor_des==0 && sensor_state!=0)
   {
        disable_allF();
        disable_allB();
   };
  
} 

 
void start(void)                 // 
{   
  while(1)
  {
     check_env();
     decision();
     h=next_move();
     go(h);
     led_on();
     delay(100);
     led_off();
     
  };
}  


void main(void)
{  
  int i;
  //  
  PORTB=0x00;
  DDRB=0x00;
  PORTC=0x00;
  DDRC=0x00;
  PORTD=0x00;
  DDRD=0xFF;
  TCCR0=0x00;
  TCNT0=0x00;

  // Timer/Counter 1 initialization
  // Clock source: System Clock
  // Clock value: 15,625 kHz
  // Mode: Normal top=FFFFh
  // OC1A output: Discon. 
  // OC1B output: Discon.
  // Noise Canceler: Off
  // Input Capture on Falling Edge
  // Timer 1 Overflow Interrupt: Off
  // Input Capture Interrupt: Off
  // Compare A Match Interrupt: On
  // Compare B Match Interrupt: Off
 
  TCCR1A=0x00; 
  TCCR1B=0x0D;
  TCNT1H=0x00;
  TCNT1L=0x00;
  ICR1H=0x00;
  ICR1L=0x00;
  OCR1AH=0x00;
  OCR1AL=0x0F;
  OCR1BH=0x00;
  OCR1BL=0x00;
 
  // Timer/Counter 2 initialization
  // Clock source: System Clock
  // Clock value: Timer 2 Stopped
  // Mode: Normal top=FFh
  // OC2 output: Disconnected
  ASSR=0x00;
  TCCR2=0x00;
  TCNT2=0x00;
  OCR2=0x00;

  // External Interrupt(s) initialization
  // INT0: Off
  // INT1: Off
  MCUCR=0x00;

  // Timer(s)/Counter(s) Interrupt(s) initialization
  TIMSK=0x10;

  // Analog Comparator initialization
  // Analog Comparator: Off
  // Analog Comparator Input Capture by Timer/Counter 1: Off
  ACSR=0x80;
  SFIOR=0x00;

  // ADC initialization
  // ADC Clock frequency: 1000,000 kHz
  // ADC Voltage Reference: AVCC pin
  ADMUX=ADC_VREF_TYPE & 0xff;
  ADCSRA=0x8C;

  // Global enable interrupts
  #asm("sei")

  while (1)
  {
      now=1;
      for (i=0;i<=5;i++) //   ,        
      { 
        led_on();
        delay(500);
        led_off();
        delay(500);
       }; 
        
      start();   
  
  };
     


}

