/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.7 beta 5 Professional
Automatic Program Generator
 Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : FiBo
Version : 0.1
Date    : 13.02.2008
Author  : Fox89                   
Company : Licrym                        
Comments: 


Chip type           : ATmega8L
Program type        : Application
Clock frequency     : 16,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/
#include <mega8.h>
#include <delay.h>

// (100)=1sec
void f(int t){// move foward
PORTC.1=0;
PORTC.2=1;
PORTC.3=0;
PORTC.4=0;
if(t!=0) delay_ms(t);
}
void b(int t){// move back
PORTC.1=1;
PORTC.2=0;
PORTC.3=0;
PORTC.4=0;
if(t!=0) delay_ms(t);
}
void fl(int t){// move foward and left
PORTC.1=0;
PORTC.2=1;
PORTC.3=0;
PORTC.4=1;
if(t!=0) delay_ms(t);
} 
void fr(int t){// move foward and right
PORTC.1=0;
PORTC.2=1;
PORTC.3=1;
PORTC.4=0;
if(t!=0) delay_ms(t);
} 
void bl(int t){// move back and left
PORTC.1=1;
PORTC.2=0;
PORTC.3=0;
PORTC.4=1;
if(t!=0) delay_ms(t);
} 
void br(int t){// move back and right
PORTC.1=1;
PORTC.2=0;
PORTC.3=1;
PORTC.4=0;
if(t!=0) delay_ms(t);
} 
void stop(void){//stop all moving
PORTC.1=0;
PORTC.2=0;
PORTC.3=0;
PORTC.4=0;
} 
void led_on(void){ //turn on the led
PORTC.0=1;}
void led_off(void){ //turn off the led
PORTC.0=0;}

void main(void)
{ int i;

PORTB=0x00;
DDRB=0x00;
PORTC=0x00;
DDRC=0x7F;
PORTD=0x00;
DDRD=0x00;
TCCR0=0x00;
TCNT0=0x00;
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;
MCUCR=0x00;
TIMSK=0x00;
ACSR=0x80;
SFIOR=0x00;

while (1)
      {
      
      for (i=0;i<=3;i++) { 
        led_on();
        delay_ms(50);
        led_off();
        delay_ms(50);
      };
      
      f(100);
      fl(100);
      stop();
      br(100);
      f(100);
      stop();
      b(100);
      bl(50);
      br(50);
      fr(100);
      stop();
      

      };
}
