/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.7 beta 5 Professional
Automatic Program Generator
 Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 17.02.2008
Author  : Spiritus Sancti                            
Company : Licrym.org                            
Comments: 


Chip type           : ATmega8
Program type        : Application
Clock frequency     : 16,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>
#include <stdlib.h>


// Timer 1 output compare A interrupt service routine

unsigned int gtime;
  
unsigned char d[7][7]={  //  
//          STO  F    FR    FL   B   BR  BL
/*STO*/     {1, 18,   18,   18, 18, 17, 13},
/*F  */     {7,  26,  21,   21, 10,  8,  7},
/*FR */     {7,  23,  23,   27,  8,  6,  6},
/*FL */     {7,  23,   7,   43,  8,  6,  6},
/*B  */     { 4, 10,  10,    5, 28, 22, 21},
/*BR */     { 6, 13,   9,    8, 35, 22,  7},
/*BL */     {16,  8,   6,    6, 35,  8, 21}
};  

unsigned char now, h;

int gTimeOfMove = 1000; //     

interrupt [TIM1_COMPA] void timer1_compa_isr(void)      //   1/1041  (1041,666 )
{
if (gtime!=0)--gtime;   
}


void delay (unsigned int time){//   ,  65535
gtime=time;
while(gtime!=0){};
} 

void f(int t){// move foward
PORTC.1=0;
PORTC.2=1;
PORTC.3=0;
PORTC.4=0;
if(t!=0) delay(t);
}
void b(int t){// move back
PORTC.1=1;
PORTC.2=0;
PORTC.3=0;
PORTC.4=0;
if(t!=0) delay(t);
}
void fl(int t){// move foward and left
PORTC.1=0;
PORTC.2=1;
PORTC.3=0;
PORTC.4=1;
if(t!=0) delay(t);
} 
void fr(int t){// move foward and right
PORTC.1=0;
PORTC.2=1;
PORTC.3=1;
PORTC.4=0;
if(t!=0) delay(t);
} 
void bl(int t){// move back and left
PORTC.1=1;
PORTC.2=0;
PORTC.3=0;
PORTC.4=1;
if(t!=0) delay(t);
} 
void br(int t){// move back and right
PORTC.1=1;
PORTC.2=0;
PORTC.3=1;
PORTC.4=0;
if(t!=0) delay(t);
} 
void stop(int t){//stop all moving
PORTC.1=0;
PORTC.2=0;
PORTC.3=0;
PORTC.4=0;
if(t!=0) delay(t);
} 
void led_on(void){ //turn on the led
PORTC.0=1;}
void led_off(void){ //turn off the led
PORTC.0=0;}    

void go(unsigned char napr){         //       
switch(napr){
  case 1:
    stop(gTimeOfMove);
    break; 
  case 2:
    f(gTimeOfMove);
    break;

  case 3:
    fr(gTimeOfMove);
    break;

  case 4:
    fl(gTimeOfMove);
    break;

  case 5:
    b(gTimeOfMove);
    break;

  case 6:
    br(gTimeOfMove);
    break;

  case 7:
    bl(gTimeOfMove);
    break;
};
}

unsigned char next_move(void){     //       
int a, b, c;
a = rand()/327; //0..99  
c=0;
for (b=1; b<=7; b++){       //  
        if(a > c && a < (d[now][b]+c) ) break;
        c=c+d[now][b];
}; 
if (b==8)b=1;   //  8              
now = b;
return b;
};    

void start(void){ // .   
while(1){
h=next_move();
go(h);
led_on();
delay(100);
led_off();
}
};

void main(void)
{  int i;
// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;
// Port C initialization
// Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTC=0x00;
DDRC=0x7F;
// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;
// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;
// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 15,625 kHz
// Mode: CTC top=OCR1A
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: On
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x0D;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;//  
OCR1AL=0x0F;//
OCR1BH=0x00;
OCR1BL=0x00;
// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;
// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;
// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x10;
// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;
// Global enable interrupts
#asm("sei")

while (1)
      {     
      now=1;
      for (i=0;i<=5;i++) { //   
        led_on();
        delay(500);
        led_off();
        delay(500);
      };
     start();    
      };
} 
