/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.7 beta 5 Professional
Automatic Program Generator
 Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 17.02.2008
Author  : F4CG                            
Company : F4CG                            
Comments: 


Chip type           : ATmega8
Program type        : Application
Clock frequency     : 16,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega8


#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm


//#include <stdio.h>
/* CodeVisionAVR C Compiler
   Prototypes for standard library functions

   (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.
*/




#pragma used+

int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib




// Timer 1 output compare A interrupt service routine

unsigned int gtime;
  
unsigned char d[7][7]={  //  
//          STO  F    FR    FL   B   BR  BL
/*STO*/     {1, 18,   18,   18, 18, 17, 13},
/*F  */     {7,  26,  21,   21, 10,  8,  7},
/*FR */     {7,  23,  23,   27,  8,  6,  6},
/*FL */     {7,  23,   7,   43,  8,  6,  6},
/*B  */     { 4, 10,  10,    5, 28, 22, 21},
/*BR */     { 6, 13,   9,    8, 35, 22,  7},
/*BL */     {16,  8,   6,    6, 35,  8, 21}
};  

//enum direction {STOP=1, F, FR, FL, B, BR, BL}; //     direction
//enum direction now, h;
unsigned char now, h;
                            // dir  direction   

int gTimeOfMove = 1000; //    
interrupt [7] void timer1_compa_isr(void)      //   1/1041  (1041,666 )
{
if (gtime!=0)--gtime;   
}

// Declare your global variables here
 

void delay (unsigned int time){//   ,  65535
gtime=time;
while(gtime!=0){};
} 

void f(int t){// move foward
PORTC.1=0;
PORTC.2=1;
PORTC.3=0;
PORTC.4=0;
if(t!=0) delay(t);
}
void b(int t){// move back
PORTC.1=1;
PORTC.2=0;
PORTC.3=0;
PORTC.4=0;
if(t!=0) delay(t);
}
void fl(int t){// move foward and left
PORTC.1=0;
PORTC.2=1;
PORTC.3=0;
PORTC.4=1;
if(t!=0) delay(t);
} 
void fr(int t){// move foward and right
PORTC.1=0;
PORTC.2=1;
PORTC.3=1;
PORTC.4=0;
if(t!=0) delay(t);
} 
void bl(int t){// move back and left
PORTC.1=1;
PORTC.2=0;
PORTC.3=0;
PORTC.4=1;
if(t!=0) delay(t);
} 
void br(int t){// move back and right
PORTC.1=1;
PORTC.2=0;
PORTC.3=1;
PORTC.4=0;
if(t!=0) delay(t);
} 
void stop(int t){//stop all moving
PORTC.1=0;
PORTC.2=0;
PORTC.3=0;
PORTC.4=0;
if(t!=0) delay(t);
} 
void led_on(void){ //turn on the led
PORTC.0=1;}
void led_off(void){ //turn off the led
PORTC.0=0;}    

void go(unsigned char napr){         //       

switch(napr){
  case 1:
    stop(gTimeOfMove);
    break; 
  case 2:
    f(gTimeOfMove);
    break;

  case 3:
    fr(gTimeOfMove);
    break;

  case 4:
    fl(gTimeOfMove);
    break;

  case 5:
    b(gTimeOfMove);
    break;

  case 6:
    br(gTimeOfMove);
    break;

  case 7:
    bl(gTimeOfMove);
    break;
};
}

unsigned char next_move(void){     //       
int a, b, c;
a = rand()/327; //0..99  
c=0;
for (b=1; b<=7; b++){       //  
        if(a > c && a < (d[now][b]+c) ) break;
        c=c+d[now][b];
}; 
if (b==8)b=1;              
now = b;
return b;
};    

void start(void){ // .   

while(1){
h=next_move();
go(h);
led_on();
delay(100);
led_off();
}
};

void main(void)
{  int i;
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTC=0x00;
DDRC=0x7F;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 15,625 kHz
// Mode: CTC top=OCR1A
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: On
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x0D;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;//  
OCR1AL=0x0F;//
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x10;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// Global enable interrupts
#asm("sei")

while (1)
      {     
       now=1;
      for (i=0;i<=5;i++) { //   
        led_on();
        delay(500);
        led_off();
        delay(500);
      };
      
      
     start();
     
     
      };
} 
